Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class JComboBox

    java.lang.Object
      |
      +--java.awt.Component
            |
            +--java.awt.Container
                  |
                  +--javax.swing.JComponent
                        |
                        +--javax.swing.JComboBox

All Implemented Interfaces:
  Accessible, ActionListener, EventListener, ImageObserver, ItemSelectable, ListDataListener, MenuContainer, Serializable

public class JComboBox
extends JComponent
implements ItemSelectable, ListDataListener, ActionListener, Accessible

A component that combines a button or text field and a drop-down list. The user can select a value from the drop-down list, which appears at the user's request. If you make the combo box editable, then the combo box includes a text field into which the user can type a value. For examples and information on using combo boxes see How to Use Combo Boxes, a section in The Java Tutorial.

For the keyboard keys used by this component in the standard Look and Feel (L&F) renditions, see the JComboBox key assignments.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  Serialized Form

Inner Class Summary
`protected class` | `JComboBox.AccessibleJComboBox` This class implements accessibility support for the `JComboBox` class.
`static interface` | `JComboBox.KeySelectionManager` The interface that defines a `KeySelectionManager`.

Inner classes inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Inner classes inherited from class java.awt.Container
`Container.AccessibleAWTContainer`

Inner classes inherited from class java.awt.Component
`Component.AccessibleAWTComponent`

Field Summary
`protected String` | `actionCommand`
`protected ComboBoxModel` | `dataModel`
`protected ComboBoxEditor` | `editor`
`protected boolean` | `isEditable`
`protected JComboBox.KeySelectionManager` | `keySelectionManager`
`protected boolean` | `lightWeightPopupEnabled`
`protected int` | `maximumRowCount`
`protected ListCellRenderer` | `renderer`
`protected Object` | `selectedItemReminder`

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`JComboBox()` Creates a `JComboBox` with a default data model.
`JComboBox(ComboBoxModel aModel)` Creates a `JComboBox` that takes it's items from an existing `ComboBoxModel`.
`JComboBox(Object[] items)` Creates a `JComboBox` that contains the elements in the specified array.
`JComboBox(Vector items)` Creates a `JComboBox` that contains the elements in the specified Vector.

Method Summary
`void` | `actionPerformed(ActionEvent e)` This method is public as an implementation side effect.
`void` | `addActionListener(ActionListener l)` Adds an `ActionListener`.
`void` | `addItem(Object anObject)` Adds an item to the item list.
`void` | `addItemListener(ItemListener aListener)` Adds an `ItemListener`.
`void` | `configureEditor(ComboBoxEditor anEditor, Object anItem)` Initializes the editor with the specified item.
`protected void` | `configurePropertiesFromAction(Action a)` Factory method which sets the `ActionEvent` source's properties according to values from the `Action` instance.
`void` | `contentsChanged(ListDataEvent e)` This method is public as an implementation side effect.
`protected PropertyChangeListener` | `createActionPropertyChangeListener(Action a)` Factory method which creates the `PropertyChangeListener` used to update the `ActionEvent` source as properties change on its `Action` instance.
`protected JComboBox.KeySelectionManager` | `createDefaultKeySelectionManager()` Returns an instance of the default key-selection manager.
`protected void` | `fireActionEvent()` Notifies all listeners that have registered interest for notification on this event type.
`protected void` | `fireItemStateChanged(ItemEvent e)` Notifies all listeners that have registered interest for notification on this event type.
`AccessibleContext` | `getAccessibleContext()` Gets the AccessibleContext associated with this JComboBox.
`Action` | `getAction()` Returns the currently set `Action` for this `ActionEvent` source, or `null` if no `Action` is set.
`String` | `getActionCommand()` Returns the action command that is included in the event sent to action listeners.
`ComboBoxEditor` | `getEditor()` Returns the editor used to paint and edit the selected item in the `JComboBox` field.
`Object` | `getItemAt(int index)` Returns the list item at the specified index.
`int` | `getItemCount()` Returns the number of items in the list.
`JComboBox.KeySelectionManager` | `getKeySelectionManager()` Returns the list's key-selection manager.
`int` | `getMaximumRowCount()` Returns the maximum number of items the combo box can display without a scrollbar
`ComboBoxModel` | `getModel()` Returns the data model currently used by the `JComboBox`.
`ListCellRenderer` | `getRenderer()` Returns the renderer used to display the selected item in the `JComboBox` field.
`int` | `getSelectedIndex()` Returns the first item in the list that matches the given item.
`Object` | `getSelectedItem()` Returns the currently selected item.
`Object[]` | `getSelectedObjects()` Returns an array containing the selected item.
`ComboBoxUI` | `getUI()` Returns the L&F object that renders this component.
`String` | `getUIClassID()` Returns the name of the L&F class that renders this component.
`void` | `hidePopup()` Causes the combo box to close its popup window.
`void` | `insertItemAt(Object anObject, int index)` Inserts an item into the item list at a given index.
`protected void` | `installAncestorListener()`
`void` | `intervalAdded(ListDataEvent e)` Invoked items have been added to the internal data model.
`void` | `intervalRemoved(ListDataEvent e)` Invoked when values have been removed from the data model.
`boolean` | `isEditable()` Returns true if the `JComboBox` is editable.
`boolean` | `isFocusTraversable()` Returns true if the component can receive the focus.
`boolean` | `isLightWeightPopupEnabled()` Returns true if lightweight (all-Java) popups are in use, or false if heavyweight (native peer) popups are being used.
`boolean` | `isPopupVisible()` Determines the visibility of the popup.
`protected String` | `paramString()` Returns a string representation of this `JComboBox`.
`void` | `processKeyEvent(KeyEvent e)` Handles `KeyEvent`s, looking for the Tab key.
`void` | `removeActionListener(ActionListener l)` Removes an `ActionListener`.
`void` | `removeAllItems()` Removes all items from the item list.
`void` | `removeItem(Object anObject)` Removes an item from the item list.
`void` | `removeItemAt(int anIndex)` Removes the item at `anIndex` This method works only if the `JComboBox` uses the default data model.
`void` | `removeItemListener(ItemListener aListener)` Removes an `ItemListener`.
`protected void` | `selectedItemChanged()` This method is called when the selected item changes.
`boolean` | `selectWithKeyChar(char keyChar)` Selects the list item that correponds to the specified keyboard character and returns true, if there is an item corresponding to that character.
`void` | `setAction(Action a)` Sets the `Action` for the `ActionEvent` source.
`void` | `setActionCommand(String aCommand)` Sets the action commnand that should be included in the event sent to action listeners.
`void` | `setEditable(boolean aFlag)` Determines whether the `JComboBox` field is editable.
`void` | `setEditor(ComboBoxEditor anEditor)` Sets the editor used to paint and edit the selected item in the `JComboBox` field.
`void` | `setEnabled(boolean b)` Enables the combo box so that items can be selected.
`void` | `setKeySelectionManager(JComboBox.KeySelectionManager aManager)` Sets the object that translates a keyboard character into a list selection.
`void` | `setLightWeightPopupEnabled(boolean aFlag)` When displaying the popup, `JComboBox` choose to use a light weight popup if it fits.
`void` | `setMaximumRowCount(int count)` Sets the maximum number of rows the `JComboBox` displays.
`void` | `setModel(ComboBoxModel aModel)` Sets the data model that the `JComboBox` uses to obtain the list of items.
`void` | `setPopupVisible(boolean v)` Sets the visibility of the popup.
`void` | `setRenderer(ListCellRenderer aRenderer)` Sets the renderer that paints the item selected from the list in the JComboBox field.
`void` | `setSelectedIndex(int anIndex)` Selects the item at index `anIndex`.
`void` | `setSelectedItem(Object anObject)` Sets the selected item in the `JComboBox` by specifying the object in the list.
`void` | `setUI(ComboBoxUI ui)` Sets the L&F object that renders this component.
`void` | `showPopup()` Causes the combo box to display its popup window.
`void` | `updateUI()` Notification from the `UIFactory` that the L&F has changed.

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addNotify, addPropertyChangeListener, addPropertyChangeListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAutoscrolls, getBorder, getBounds, getClientProperty, getComponentGraphics, getConditionForKeyStroke, getDebugGraphicsOptions, getGraphics, getHeight, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getVerifyInputWhenFocusTarget, getVisibleRect, getWidth, getX, getY, grabFocus, hasFocus, hide, isDoubleBuffered, isFocusCycleRoot, isLightweightComponent, isManagingFocus, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isPreferredSizeSet, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processFocusEvent, processKeyBinding, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setDebugGraphicsOptions, setDoubleBuffered, setFont, setForeground, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getLayout, insets, invalidate, isAncestorOf, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setLayout, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, getBackground, getBounds, getColorModel, getComponentOrientation, getCursor, getDropTarget, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getInputContext, getInputMethodRequests, getLocale, getLocation, getLocationOnScreen, getName, getParent, getPeer, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, imageUpdate, inside, isDisplayable, isEnabled, isLightweight, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### dataModel

    protected ComboBoxModel dataModel

### renderer

    protected ListCellRenderer renderer

### editor

    protected ComboBoxEditor editor

### maximumRowCount

    protected int maximumRowCount

### isEditable

    protected boolean isEditable

### selectedItemReminder

    protected Object selectedItemReminder

### keySelectionManager

    protected JComboBox.KeySelectionManager keySelectionManager

### actionCommand

    protected String actionCommand

### lightWeightPopupEnabled

    protected boolean lightWeightPopupEnabled

Constructor Detail

### JComboBox

    public JComboBox(ComboBoxModel aModel)

  Creates a `JComboBox` that takes it's items from an existing `ComboBoxModel`. Since the `ComboBoxModel` is provided, a combo box created using this constructor does not create a default combo box model and may impact how the insert, remove and add methods behave.
  Parameters:
    `aModel` - the `ComboBoxModel` that provides the displayed list of items
  See Also:
    `DefaultComboBoxModel`

### JComboBox

    public JComboBox(Object[] items)

  Creates a `JComboBox` that contains the elements in the specified array. By default the first item in the array (and therefore the data model) becomes selected.
  Parameters:
    `items` - an array of objects to insert into the combo box
  See Also:
    `DefaultComboBoxModel`

### JComboBox

    public JComboBox(Vector items)

  Creates a `JComboBox` that contains the elements in the specified Vector. By default the first item in the vector and therefore the data model) becomes selected.
  Parameters:
    `items` - an array of vectors to insert into the combo box
  See Also:
    `DefaultComboBoxModel`

### JComboBox

    public JComboBox()

  Creates a `JComboBox` with a default data model. The default data model is an empty list of objects. Use `addItem` to add items. By default the first item in the data model becomes selected.
  See Also:
    `DefaultComboBoxModel`

Method Detail

### installAncestorListener

    protected void installAncestorListener()

### setUI

    public void setUI(ComboBoxUI ui)

  Sets the L&F object that renders this component.
  Parameters:
    `ui` - the `ComboBoxUI` L&F object
  See Also:
    `UIDefaults.getUI(javax.swing.JComponent)`

### updateUI

    public void updateUI()

  Notification from the `UIFactory` that the L&F has changed.
  Overrides:
    `updateUI` in class `JComponent`
  See Also:
    `JComponent.updateUI()`

### getUIClassID

    public String getUIClassID()

  Returns the name of the L&F class that renders this component.
  Overrides:
    `getUIClassID` in class `JComponent`
  Returns:
    the string "ComboBoxUI"
  See Also:
    `JComponent.getUIClassID()`, `UIDefaults.getUI(javax.swing.JComponent)`

### getUI

    public ComboBoxUI getUI()

  Returns the L&F object that renders this component.
  Returns:
    the ComboBoxUI object that renders this component

### setModel

    public void setModel(ComboBoxModel aModel)

  Sets the data model that the `JComboBox` uses to obtain the list of items.
  Parameters:
    `aModel` - the `ComboBoxModel` that provides the displayed list of items

### getModel

    public ComboBoxModel getModel()

  Returns the data model currently used by the `JComboBox`.
  Returns:
    the `ComboBoxModel` that provides the displayed list of items

### setLightWeightPopupEnabled

    public void setLightWeightPopupEnabled(boolean aFlag)

  When displaying the popup, `JComboBox` choose to use a light weight popup if it fits. This method allows you to disable this feature. You have to do disable it if your application mixes light weight and heavy weights components.

### isLightWeightPopupEnabled

    public boolean isLightWeightPopupEnabled()

  Returns true if lightweight (all-Java) popups are in use, or false if heavyweight (native peer) popups are being used.
  Returns:
    true if lightweight popups are in use

### setEditable

    public void setEditable(boolean aFlag)

  Determines whether the `JComboBox` field is editable. An editable `JComboBox` allows the user to type into the field or selected an item from the list to initialize the field, after which it can be edited. (The editing affects only the field, the list item remains intact.) A non editable `JComboBox` displays the selected item in the field, but the selection cannot be modified.
  Parameters:
    `aFlag` - a boolean value, where true indicates that the field is editable

### isEditable

    public boolean isEditable()

  Returns true if the `JComboBox` is editable. By default, a combo box is not editable.
  Returns:
    true if the `JComboBox` is editable, else false

### setMaximumRowCount

    public void setMaximumRowCount(int count)

  Sets the maximum number of rows the `JComboBox` displays. If the number of objects in the model is greater than count, the combo box uses a scrollbar.
  Parameters:
    `count` - an integer specifying the maximum number of items to display in the list before using a scrollbar

### getMaximumRowCount

    public int getMaximumRowCount()

  Returns the maximum number of items the combo box can display without a scrollbar
  Returns:
    an integer specifying the maximum number of items that are displayed in the list before using a scrollbar

### setRenderer

    public void setRenderer(ListCellRenderer aRenderer)

  Sets the renderer that paints the item selected from the list in the JComboBox field. The renderer is used if the JComboBox is not editable. If it is editable, the editor is used to render and edit the selected item.

  The default renderer displays a string, obtained by calling the selected object's `toString` method. Other renderers can handle graphic images and composite items.

  To display the selected item, `aRenderer.getListCellRendererComponent` is called, passing the list object and an index of -1.

  Parameters:
    `aRenderer` - the `ListCellRenderer` that displays the selected item
  See Also:
    `setEditor(javax.swing.ComboBoxEditor)`

### getRenderer

    public ListCellRenderer getRenderer()

  Returns the renderer used to display the selected item in the `JComboBox` field.
  Returns:
    the `ListCellRenderer` that displays the selected item.

### setEditor

    public void setEditor(ComboBoxEditor anEditor)

  Sets the editor used to paint and edit the selected item in the `JComboBox` field. The editor is used only if the receiving `JComboBox` is editable. If not editable, the combo box uses the renderer to paint the selected item.
  Parameters:
    `anEditor` - the `ComboBoxEditor` that displays the selected item
  See Also:
    `setRenderer(javax.swing.ListCellRenderer)`

### getEditor

    public ComboBoxEditor getEditor()

  Returns the editor used to paint and edit the selected item in the `JComboBox` field.
  Returns:
    the `ComboBoxEditor` that displays the selected item

### setSelectedItem

    public void setSelectedItem(Object anObject)

  Sets the selected item in the `JComboBox` by specifying the object in the list. If `anObject` is in the list, the list displays with `anObject` selected.
  Parameters:
    `anObject` - the list object to select

### getSelectedItem

    public Object getSelectedItem()

  Returns the currently selected item.
  Returns:
    the currently selected list object from the data model

### setSelectedIndex

    public void setSelectedIndex(int anIndex)

  Selects the item at index `anIndex`.
  Parameters:
    `anIndex` - an integer specifying the list item to select, where 0 specifies the first item in the list
  Throws:
    `IllegalArgumentException` - if `anIndex` < -1 or `anIndex` is greater than or equal to size

### getSelectedIndex

    public int getSelectedIndex()

  Returns the first item in the list that matches the given item. The result is not always defined if the `JComboBox` allows selected items that are not in the list. Returns -1 if there is no selected item or if the user specified an item which is not in the list.
  Returns:
    an integer specifying the currently selected list item, where 0 specifies the first item in the list; or -1 if no item is selected or if the currently selected item is not in the list

### addItem

    public void addItem(Object anObject)

  Adds an item to the item list. This method works only if the `JComboBox` uses the default data model. `JComboBox` uses the default data model when created with the empty constructor and no other model has been set.

  Warning: Focus and keyboard navigation problems may arise if you add duplicate String objects. A workaround is to add new objects instead of String objects and make sure that the toString() method is defined. For example:

         comboBox.addItem(makeObj("Item 1"));
         comboBox.addItem(makeObj("Item 1"));
         ...
         private Object makeObj(final String item)  {
           return new Object() { public String toString() { return item; } };
         }

  Parameters:
    `anObject` - the Object to add to the list

### insertItemAt

    public void insertItemAt(Object anObject,
                             int index)

  Inserts an item into the item list at a given index. This method works only if the `JComboBox` uses the default data model. `JComboBox` uses the default data model when created with the empty constructor and no other model has been set.
  Parameters:
    `anObject` - the `Object` to add to the list
    `index` - an integer specifying the position at which to add the item

### removeItem

    public void removeItem(Object anObject)

  Removes an item from the item list. This method works only if the `JComboBox` uses the default data model. `JComboBox` uses the default data model when created with the empty constructor and no other model has been set.
  Parameters:
    `anObject` - the object to remove from the item list

### removeItemAt

    public void removeItemAt(int anIndex)

  Removes the item at `anIndex` This method works only if the `JComboBox` uses the default data model. `JComboBox` uses the default data model when created with the empty constructor and no other model has been set.
  Parameters:
    `anIndex` - an int specifying the idex of the item to remove, where 0 indicates the first item in the list

### removeAllItems

    public void removeAllItems()

  Removes all items from the item list.

### showPopup

    public void showPopup()

  Causes the combo box to display its popup window.
  See Also:
    `setPopupVisible(boolean)`

### hidePopup

    public void hidePopup()

  Causes the combo box to close its popup window.
  See Also:
    `setPopupVisible(boolean)`

### setPopupVisible

    public void setPopupVisible(boolean v)

  Sets the visibility of the popup.

### isPopupVisible

    public boolean isPopupVisible()

  Determines the visibility of the popup.

### addItemListener

    public void addItemListener(ItemListener aListener)

  Adds an `ItemListener`. `aListener` will receive an event when the selected item changes.
  Specified by:
    `addItemListener` in interface `ItemSelectable`
  Parameters:
    `aListener` - the `ItemListener` that is to be notified

### removeItemListener

    public void removeItemListener(ItemListener aListener)

  Removes an `ItemListener`.
  Specified by:
    `removeItemListener` in interface `ItemSelectable`
  Parameters:
    `aListener` - the `ItemListener` to remove

### addActionListener

    public void addActionListener(ActionListener l)

  Adds an `ActionListener`. The listener will receive an action event the user finishes making a selection.
  Parameters:
    `l` - the `ActionListener` that is to be notified

### removeActionListener

    public void removeActionListener(ActionListener l)

  Removes an `ActionListener`.
  Parameters:
    `l` - the `ActionListener` to remove

### setActionCommand

    public void setActionCommand(String aCommand)

  Sets the action commnand that should be included in the event sent to action listeners.
  Parameters:
    `aCommand` - a string containing the "command" that is sent to action listeners; the same listener can then do different things depending on the command it receives

### getActionCommand

    public String getActionCommand()

  Returns the action command that is included in the event sent to action listeners.
  Returns:
    the string containing the "command" that is sent to action listeners.

### setAction

    public void setAction(Action a)

  Sets the `Action` for the `ActionEvent` source. The new `Action` replaces any previously set `Action` but does not affect `ActionListeners` independantly added with `addActionListener`. If the `Action` is already a registered `ActionListener` for the `ActionEvent` source, it is not re-registered.

  A side-effect of setting the `Action` is that the `ActionEvent` source's properties are immedately set from the values in the `Action` (performed by the method `configurePropertiesFromAction`) and subsequently updated as the `Action`'s properties change (via a `PropertyChangeListener` created by the method `createActionPropertyChangeListener`.

  Parameters:
    `a` - the `Action` for the `JComboBox`, or `null`.
  Since:
    1.3
  See Also:
    `Action`, `getAction()`, `configurePropertiesFromAction(javax.swing.Action)`, `createActionPropertyChangeListener(javax.swing.Action)`

### getAction

    public Action getAction()

  Returns the currently set `Action` for this `ActionEvent` source, or `null` if no `Action` is set.
  Returns:
    the `Action` for this `ActionEvent` source; or `null`
  Since:
    1.3
  See Also:
    `Action`, `setAction(javax.swing.Action)`

### configurePropertiesFromAction

    protected void configurePropertiesFromAction(Action a)

  Factory method which sets the `ActionEvent` source's properties according to values from the `Action` instance. The properties which are set may differ for subclasses. By default, the properties which get set are `Enabled` and `ToolTipText`.
  Parameters:
    `a` - the `Action` from which to get the properties, or `null`
  Since:
    1.3
  See Also:
    `Action`, `setAction(javax.swing.Action)`

### createActionPropertyChangeListener

    protected PropertyChangeListener createActionPropertyChangeListener(Action a)

  Factory method which creates the `PropertyChangeListener` used to update the `ActionEvent` source as properties change on its `Action` instance. Subclasses may override this in order to provide their own `PropertyChangeListener` if the set of properties which should be kept up to date differs from the default properties (Text, Icon, Enabled, ToolTipText). Note that `PropertyChangeListeners` should avoid holding strong references to the `ActionEvent` source, as this may hinder garbage collection of the `ActionEvent` source and all components in its containment hierarchy.
  Since:
    1.3
  See Also:
    `Action`, `setAction(javax.swing.Action)`

### fireItemStateChanged

    protected void fireItemStateChanged(ItemEvent e)

  Notifies all listeners that have registered interest for notification on this event type.
  Parameters:
    `e` - the event of interest
  See Also:
    `EventListenerList`

### fireActionEvent

    protected void fireActionEvent()

  Notifies all listeners that have registered interest for notification on this event type.
  Parameters:
    `e` - the event of interest
  See Also:
    `EventListenerList`

### selectedItemChanged

    protected void selectedItemChanged()

  This method is called when the selected item changes. Its default implementation notifies the item listeners.

### getSelectedObjects

    public Object[] getSelectedObjects()

  Returns an array containing the selected item. This method is implemented for compatibility with `ItemSelectable`.
  Specified by:
    `getSelectedObjects` in interface `ItemSelectable`

### actionPerformed

    public void actionPerformed(ActionEvent e)

  This method is public as an implementation side effect. do not call or override.
  Specified by:
    `actionPerformed` in interface `ActionListener`

### contentsChanged

    public void contentsChanged(ListDataEvent e)

  This method is public as an implementation side effect. do not call or override.
  Specified by:
    `contentsChanged` in interface `ListDataListener`
  See Also:
    `ListDataListener`

### selectWithKeyChar

    public boolean selectWithKeyChar(char keyChar)

  Selects the list item that correponds to the specified keyboard character and returns true, if there is an item corresponding to that character. Otherwise, returns false.
  Parameters:
    `keyChar` - a char, typically this is a keyboard key typed by the user

### intervalAdded

    public void intervalAdded(ListDataEvent e)

  Invoked items have been added to the internal data model. The "interval" includes the first and last values added.
  Specified by:
    `intervalAdded` in interface `ListDataListener`
  See Also:
    `ListDataListener`

### intervalRemoved

    public void intervalRemoved(ListDataEvent e)

  Invoked when values have been removed from the data model. The "interval" includes the first and last values removed.
  Specified by:
    `intervalRemoved` in interface `ListDataListener`
  See Also:
    `ListDataListener`

### setEnabled

    public void setEnabled(boolean b)

  Enables the combo box so that items can be selected. When the combo box is disabled, items cannot be selected and values cannot be typed into its field (if it is editable).
  Overrides:
    `setEnabled` in class `JComponent`
  Parameters:
    `b` - a boolean value, where true enables the component and false disables it

### configureEditor

    public void configureEditor(ComboBoxEditor anEditor,
                                Object anItem)

  Initializes the editor with the specified item.
  Parameters:
    `anEditor` - the `ComboBoxEditor` that displays the list item in the combo box field and allows it to be edited
    `anItem` - the object to display and edit in the field

### processKeyEvent

    public void processKeyEvent(KeyEvent e)

  Handles `KeyEvent`s, looking for the Tab key. If the Tab key is found, the popup window is closed.
  Overrides:
    `processKeyEvent` in class `JComponent`
  Parameters:
    `e` - the `KeyEvent` containing the keyboard key that was pressed

### isFocusTraversable

    public boolean isFocusTraversable()

  Returns true if the component can receive the focus. In this case, the component returns false if it is editable, so that the `Editor` object receives the focus, instead of the component.
  Overrides:
    `isFocusTraversable` in class `JComponent`
  Returns:
    true if the component can receive the focus, else false

### setKeySelectionManager

    public void setKeySelectionManager(JComboBox.KeySelectionManager aManager)

  Sets the object that translates a keyboard character into a list selection. Typically, the first selection with a matching first character becomes the selected item.

### getKeySelectionManager

    public JComboBox.KeySelectionManager getKeySelectionManager()

  Returns the list's key-selection manager.
  Returns:
    the `KeySelectionManager` currently in use

### getItemCount

    public int getItemCount()

  Returns the number of items in the list.
  Returns:
    an integer equal to the number of items in the list

### getItemAt

    public Object getItemAt(int index)

  Returns the list item at the specified index. If `index` is out of range (less than zero or greater than or equal to size) it will return `null`.
  Parameters:
    `index` - an integer indicating the list position, where the first item starts at zero
  Returns:
    the `Object` at that list position; or `null` if out of range

### createDefaultKeySelectionManager

    protected JComboBox.KeySelectionManager createDefaultKeySelectionManager()

  Returns an instance of the default key-selection manager.
  Returns:
    the `KeySelectionManager` currently used by the list
  See Also:
    `setKeySelectionManager(javax.swing.JComboBox.KeySelectionManager)`

### paramString

    protected String paramString()

  Returns a string representation of this `JComboBox`. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.
  Overrides:
    `paramString` in class `JComponent`
  Returns:
    a string representation of this `JComboBox`

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Gets the AccessibleContext associated with this JComboBox. For combo boxes, the AccessibleContext takes the form of an AccessibleJComboBox. A new AccessibleJComboBox instance is created if necessary.
  Specified by:
    `getAccessibleContext` in interface `Accessible`
  Overrides:
    `getAccessibleContext` in class `JComponent`
  Returns:
    an AccessibleJComboBox that serves as the AccessibleContext of this JComboBox

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.